import pickle
from pathlib import Path

"""
Ved hjælp af funktionerne her gemmes materialelisten hver gang der trykkes på
"gem"- eller "gem og luk"-knappen.
Filen gives efternavnet "file" for at gøre det klart, at der er tale om en binær
fil og ikke fx en "txt"-fil.

Denne kode (og ovenstående uddybning) er meget inspireret af:
https://stackoverflow.com/questions/82831/how-do-i-check-whether-a-file-exists-without-exceptions
http://www.albertgao.xyz/2016/12/02/how-to-save-a-python-object-to-disk-and-retrieve-it-later/
(Fremgår også af litteraturlisten.)
"""

filnavn = "gemtMaterialeliste.file"


def findes_materialeliste():
    # Tjekker om filen "filnavn" findes på det sted, hvor det kørende programs
    # .py-fil ligger.
    fil = Path(filnavn)
    if fil.is_file():
        return True
    else:
        return False


def gem_materialeliste(materialeliste):
    # Materialelisten gemmes binært i filen "filnavn" på det sted, hvor det
    # kørende programs .py-fil ligger.
    with open(filnavn, "wb") as gm:
        pickle.dump(materialeliste, gm, pickle.HIGHEST_PROTOCOL)


def hent_gemt_materialeliste():
    # Den gemte materialeliste åbnes binært fra filen "filnavn" - på det sted,
    # hvor det kørende programs .py-fil ligger - og returneres.
    with open(filnavn, "rb") as gm:
        gemt_materialeliste = pickle.load(gm)
        return gemt_materialeliste
