import unittest
from klasser import Bog


class TestBog(unittest.TestCase):
    """Tester underklassen Bog i filen klasser.py"""

    def setUp(self):
        """Deklarering og initiering af bøger, som kan bruges i alle testene."""
        self.bog1 = Bog()
        self.bog2 = Bog(21, "Ude af verden", 3, 0, 0, 2011, "Karl Ove Knausgård",680)

    def test_match_noget_ingen_argumenter_succes(self):
        """Der skal stå N/A i bog1's titel/forfatter (står i begge.)"""
        succes = self.bog1.match_noget("N/A")
        self.assertTrue(succes)

    def test_match_noget_argumenter_succes(self):
        """'arl' er en del af bog2's forfatter"""
        succes = self.bog2.match_noget("arl")
        self.assertTrue(succes)

    def test_match_titel_succes(self):
        """'de a' er en del af bog2's titel"""
        succes = self.bog2.match_titel("de a")
        self.assertTrue(succes)

    def test_match_titel_fiasko(self):
        """'arl' er ikke en del af bog2's titel"""
        fiasko = self.bog2.match_titel("arl")
        self.assertFalse(fiasko)

    def test_udlaan_graense(self):
        """bog2's antal er 3, så højst kan skal kunne udlånes"""
        for x in range(10):
            if self.bog2.udlaan_muligt():
                self.bog2.udlaan()
        self.assertEqual(3, self.bog2.antal_udlaan)

    def test_almindeligt_udlaan_umuligt_hvis_reserveret(self):
        """Reservationer skal blokere for udlån"""
        for x in range(2):
            self.bog2.reserver()
        for x in range(50):
            if self.bog2.udlaan_muligt():
                self.bog2.udlaan()
        self.assertEqual(1, self.bog2.antal_udlaan)

    def test_for_lille_udbud_melding_fiasko(self):
        """Udbuddet er for ikke for lille, hvis 6 reserveres."""
        for x in range(6):
            self.bog2.reserver()
        fiasko = self.bog2.for_lille_udbud()
        self.assertFalse(fiasko)

    def test_for_lille_udbud_melding_succes(self):
        """Udbuddet er for lille, hvis 1 udlånes og 6 reserveres."""
        if self.bog2.udlaan_muligt():
            self.bog2.udlaan()
        for x in range(6):
            self.bog2.reserver()
        succes = self.bog2.for_lille_udbud()
        self.assertTrue(succes)


unittest.main()
